//
//  LKTileLayer.m
//  Vectors
//
//  Created by Károly Lőrentey on 2011-01-01.
//  Copyright 2011 Károly Lőrentey. All rights reserved.
//

#import "LKTileLayer.h"

@implementation LKTileLayer
@synthesize index = _index;
@synthesize row = _row;
@synthesize column = _column;
@synthesize bitmapContext = _bc;

static int tileCount = 0;
static int tileIndex = 0;

- (id)init {
    self = [super init];
    if (self) {
        _index = tileIndex++;
        tileCount++;
    }
    return self;
}

- (id)initWithLayer:(id)layer {
    self = [super initWithLayer:layer];
    assert([layer isKindOfClass:LKTileLayer.class]);
    if (self) {
        LKTileLayer *tl = (LKTileLayer *)layer;
        _index = tl->_index;        
    }
    return self;
}

- (void)dealloc {
    LKRelease(_bc);
    
    tileCount--;
    if (tileCount == 0)
        tileIndex = 0;
    
    [super dealloc];
}
@end
