//
//  LKViewController.m
//  TiledLayerDemo
//
//  Created by Karoly Lorentey on 2011-10-31.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "LKViewController.h"
#import "LKTiledCanvasView.h"

@implementation LKViewController {
    LKTiledCanvasView *_tiledCanvasView;
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    _tiledCanvasView.rcdContents = CGRectMake(0, 0, 1, 1);
    _tiledCanvasView.minimumZoomScale = 1.0;
    _tiledCanvasView.maximumZoomScale = 131072.0;
    _tiledCanvasView.tileSize = CGSizeMake(256, 256);
    [_tiledCanvasView zoomToRcd:CGRectMake(0, 0, 1, 1) fast:NO];
#if DEBUG
    _tiledCanvasView.enableDebugOutput = YES;
#endif   
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    LKRelease(_tiledCanvasView);
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return YES;
}

- (void)drawTileForView:(LKTiledCanvasView *)canvasView inContext:(CGContextRef)context
{
    CGRect rcdContents = canvasView.rcdContents;
    CGContextClipToRect(context, rcdContents);
    CGContextSaveGState(context);
    CGContextTranslateCTM(context, CGRectGetMidX(rcdContents), CGRectGetMidY(rcdContents));
    rcdContents.origin.x -= CGRectGetMidX(rcdContents);
    rcdContents.origin.y -= CGRectGetMidY(rcdContents);

    CGFloat unit = CGRectGetWidth(rcdContents) / 200;
    CGRect rect = CGRectInset(rcdContents, unit / 2, unit / 2);
    CGContextSetStrokeColorWithColor(context, [UIColor blackColor].CGColor);
    CGContextSetLineWidth(context, unit);
    int i = 0;
    while (CGRectGetWidth(rect) > 0) {
        CGContextStrokeRect(context, rect);
        rect = CGRectInset(rect, 2 * unit, 2 * unit);
        CGContextRotateCTM(context, M_PI_2 / 49);
        i++;
    }
    NSLog(@"%d", i);
    CGContextRestoreGState(context);
}

@end
